`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    22:21:34 10/20/2010 
// Design Name: 
// Module Name:    clock_prescaler 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module clock_prescaler(
    input mclk50M,
	 input reset_n,
    output clk3_125M
    );

reg [3:0] scale_count;
reg [1:0] reset_state;
reg [1:0] nxt_state;

// NOTE: reset_state[] is output of state machine to reset the prescaler register
// one clock cycle for ease of simulation. Allows the 3.135 MHz clock to run almost
// all the time so that the beat and note address counters can reset properly.
 
always @(posedge mclk50M) begin
	if (reset_state[0] == 1'b1) scale_count <= 4'b0000;
	else scale_count <= scale_count + 1;
	reset_state <= nxt_state;
	end
	
always @* begin	
	case (reset_state) 
		2'b00 : if (reset_n == 0) nxt_state = 2'b01; else nxt_state = 2'b00;
		2'b01 : nxt_state = 2'b10;
		2'b10 : if (reset_n == 0) nxt_state = 2'b10; else nxt_state = 2'b00;
		default : nxt_state = 2'b00;
		endcase
	end
	
assign clk3_125M = scale_count[3];

endmodule
